<p align="center">
  <br/>
  <a href="https://opensource.org/license/agpl-v3" target="_blank"><img src="https://img.shields.io/github/license/JeziL/carvita?style=for-the-badge&color=39a9db&logoColor=000000&labelColor=ececec"></a>
  &nbsp;
  <img src="https://img.shields.io/github/actions/workflow/status/JeziL/carvita/flutter.yml?style=for-the-badge&logoColor=000000&labelColor=ececec">
  &nbsp;
  <a href="https://github.com/JeziL/carvita/releases/latest"><img src="https://img.shields.io/github/v/release/JeziL/carvita?style=for-the-badge&color=f39237&logoColor=000000&labelColor=ececec"></a>
  &nbsp;
  <a href="https://f-droid.org/packages/com.wangjinli.carvita" target="_blank"><img src="https://img.shields.io/f-droid/v/com.wangjinli.carvita?style=for-the-badge&color=f39237&logoColor=000000&labelColor=ececec"></a>
  <br/>
  <br/>
</p>

<p align="center">
  <img src="./assets/icon/icon.png" width="120" title="CarVita">
</p>

<h1 align="center">CarVita</h1>
<h3 align="center">Personal assistant for managing and predicting your vehicle's maintenance needs.</h3>

![](./.design/assets/feature_graphic/output/en/gh-header_image.jpg)

<p align="center">
  <a href="./README.md">English</a>
  &nbsp;|&nbsp;
  <a href="./.design/i18n/README_zh.md">中文</a>
</p>

## What CarVita do?

✅ **Visualize Your Vehicle's Status:** A clear dashboard provides an at-a-glance overview of your vehicles and the most urgent upcoming services.

✅ **Track Multiple Vehicles:** Manage all your cars, motorcycles, or other vehicles in one place.

✅ **Create Custom Maintenance Plans:** Input your vehicle manufacturer's recommended service schedule (both time and mileage intervals, including first service requirements) to create a plan tailored specifically to your vehicle.

✅ **Log Every Service:** Keep a detailed digital history of all maintenance performed, including date, mileage, items serviced, costs, and notes.

✅ **Get Predictions:** Calculates upcoming maintenance tasks for each item in your plan, considering both time and mileage cycles, and even predicts due dates based on your vehicle's usage patterns.

✅ **Stay Alert with Reminders:** Receive timely local notifications for upcoming services, so you can schedule appointments without stress.

## Get Started

[<img src="https://f-droid.org/badge/get-it-on.png"
    alt="Get it on F-Droid"
    height="80">](https://f-droid.org/packages/com.wangjinli.carvita)

...or download from [Github Releases](https://github.com/JeziL/carvita/releases/latest).

## Help & Support

Please submit an [issue on GitHub](https://github.com/JeziL/carvita/issues/new).

## License

This repository is available as open-source under the terms of the [GNU AGPLv3 License](./LICENSE.txt).
